/* CAP4601 Intro to AI      Final Project
 * Author: Rick Tilley      Date: 7/31/2013
 *
 * Description:
 *   Regression used to navigate in a game schenario.
 * There is a fly and a fly-killer.  They both are similar
 * in their design except one flee's and one chases.
 * Using gradient descent to predict opponent actions and
 * decrease likelyhood of failure.
 */
#include <iostream>
#include <cmath>
#include <string>
#include "fly.h"

int main () {
	Fly missile;
	Fly fly;
	std::string cmd;
	double realw[2];
	double theta;
	double xnot, ynot;
	fly.setAttack(false);
	fly.setAttention(3);
	fly.setAttentionSpan(6);
	missile.setAttack(true);
	missile.setAttention(4);
	missile.setAttentionSpan(4);
	for (int w = 0; w < 2; w++)
	{  realw[w] = ((rand() % 200) / 100.0) - 1.0;
	}
	xnot = ((rand() % 100) / 10.0) - 5.0;
	ynot = ((rand() % 100) / 10.0) - 5.0;
	theta = (double)(rand() % 360) * pi / 180.0;
	missile.setWeight(realw, theta, xnot, ynot);
	//fly.move1();  missle.move1();
	do
	{
		if (missile.move1())
			missile.pickpath(fly.dumppath());
		if (fly.move1())
			fly.pickpath(missile.dumppath());
		std::cout << "T: " << fly.gettime();
		std::cout << "   distance = " << fly.distance(missile);
		std::cout << "\n Fly:\n";
		fly.printpos();
		std::cout << " ";
		fly.printweights();
		std::cout << "\n Missile:\n";
		missile.printpos();
		std::cout << " ";
		missile.printweights();
		std::cout << '\n';
		std::cout << "Continue? [y/n]: ";
		std::cin >> cmd;
		std::cout << '\n';
	} while (cmd != "n");
	std::cout << "Program exiting.\n";
}
